defmodule LogLevel do
  def to_label(level, legacy?) do
    cond do
      level==0 && !legacy? -> :trace
      level==1 && legacy? -> :debug
      level==2 && legacy? -> :info
      level==3 && legacy? -> :warning
      level==4 && legacy? -> :error
      level==5 && !legacy? -> :fatal
      true -> :unknown
    end
  end

  def alert_recipient(level, legacy?) do
    lbl = to_label(level, legacy?)
    cond do
      lbl == :fatal || lbl == :error -> :ops
      lbl == :unknown && legacy? -> :dev1
      lbl == :unknown -> :dev2
      true -> false
    end
  end
end
